/*
    $Id: aladin.c,v 1.2 2003/02/09 11:04:34 cramer Exp $

    Some functions used by aladinlink and aladindump
 
    Copyright (C) 2002 Matthias Cramer, cramer@freestone.net
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  

*/

#include <stdio.h>

int checksum(char * buf, char verbose) {
  int i;
  unsigned int csum = 0;
  unsigned int filecsum;
  
  filecsum = (((unsigned char) buf[0x07fd] << 8) | (unsigned char) buf[0x07fc]);
  /* filecsum &= 0x0ffff; */

  if (verbose) {
    printf("File Checksum %#04x ... ", filecsum);
  }

  for (i=0; i < 0x07fc; i++) {
    csum += (unsigned char) buf[i];
  }

  csum += 0x1fe;
  csum %= 65536;
  csum &= 0x0ffff;

  if ( csum == filecsum) {
    if (verbose) {
      printf("OK\n");
    }
    return(1);
  } else {
    if (verbose) {
      printf("Error\n");
    } else {
      printf("Checksum Error, Aborting\n");
    }
    return(0);
  }
}
